import { useDropzone } from 'react-dropzone';
import {arrayMoveImmutable} from 'array-move';
import {sortableContainer, sortableElement} from 'react-sortable-hoc';
import { useState } from 'react';
import { actionPostUpsert } from '../../actions';
import { connect } from 'react-redux';

const backendURL = 'http://hipstagram.asmer.fs.a-level.com.ua';








let defaultPost =  {
    "_id":"620bb700ad55d22f3e2fb320",
    "title": null,
    "text": "aaa",
    "images": [
      {"_id":"620bb640ad55d22f3e2fb31d","url":"images/52f69596333a282940913b2f2e157fb7"},
      {"_id":"620bb66ead55d22f3e2fb31e","url":"images/b10fc2417bfe942a6e56d16d073af186"},
      {"_id":"620bb6a5ad55d22f3e2fb31f","url":"images/9111d163d7fbc66ad9ce1c170bd7002e"}
    ]
  } 



const Photo = ({photo}) => {
  return (
    <img src={`${backendURL}+"/"+${photo}`}/>
  )
}

const SortableItem = sortableElement(({image}) => 
<li>
  {image._id}
  <img src={`${backendURL}/${image.url}`}/>
  </li>);

const SortableContainer = sortableContainer(({children}) => {
  return <div>{children}</div>;
});



 const PostEditor = ({post=defaultPost, onSave, onFileDrop, fileStatus}) => {
    const [state,setState] = useState(post)
    //по файлу в дропзоне:
        //дергать onFileDrop
        //fileStatus - информация о заливке файла из redux
        //через useEffect дождаться когда файл зальется
        //и сделать setState({...state, array: [...state.array, {объект файла с бэка с _id и url}]})
    //по react-sortable-hoc
        //делаете как в пример arrayMove для state.array
    //по кнопке сохранения делаем onSave(state)
    //где-то рядом остальные поля из state типа title name text
    //но это вы уже знаете

    


    const  onSortEnd = ({oldIndex, newIndex}) => {
      setState({...state,images: arrayMoveImmutable(state.images,oldIndex,newIndex)}) 
      
    }
     console.log(state)
            
    return(
      <>
      <SortableContainer onSortEnd={onSortEnd}>
      {state.images.map((image, index) => (
          <SortableItem key={`item-${image._id}`} index={index} image={image} />
        ))}
      </SortableContainer>
      <button onClick={() => onSave(state)}>Save</button>
      </>
    )

}


const  CPostEditor = connect(null,{onSave: actionPostUpsert})(PostEditor)


 const UpsertPost = () => {
    /*  const [state, setState] = useState({...items});

     const  onSortEnd = ((oldIndex, newIndex) => {
        setState((state) => ({
            items: arrayMoveImmutable(state.items, oldIndex, newIndex),
          }));
    }) */

    return(
       /*  <SortableContainer onSortEnd={onSortEnd}>
        {state.items.map((value, index) => (
          <SortableItem key={`item-${value}`} index={index} value={value} />
        ))}
      </SortableContainer> */
      <CPostEditor/>
    )
        }


export default UpsertPost;